/*
  ____   __   __     _      ____   __   __  _   _   ____    _   _   _  __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / / | | | | / ___|  | | | | | |/ /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /  | | | | \___ \  | |_| | | ' /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |   | |_| |  ___) | |  _  | | . \   / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|    \___/  |____/  |_| |_| |_|\_\ /_/   \_\
                                                                                   
  ____   __   __     _      ____   __   __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |    / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|   /_/   \_\
                                                    
  _____   ____    ___   _____   _____   ____  
 | ____| |  _ \  |_ _| |_   _| | ____| |  _ \ 
 |  _|   | | | |  | |    | |   |  _|   | | | |
 | |___  | |_| |  | |    | |   | |___  | |_| |
 |_____| |____/  |___|   |_|   |_____| |____/ 
                                              
*/
using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;
using UnityEngine.UI;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapModName = "";
		public static string MapName = "Creel House Stranger Things";
		public static Sprite CustomSprite2 = ModAPI.LoadSprite("CustomSprite2.png");
        public static Sprite CustomSprite3 = ModAPI.LoadSprite("CustomSprite3.png");
        public static Sprite CustomSprite4 = ModAPI.LoadSprite("CustomSprite4.png");
        public static Sprite CustomSprite5 = ModAPI.LoadSprite("CustomSprite5.png");
        public static Sprite CustomSprite7 = ModAPI.LoadSprite("CustomSprite7.png");
        public static Sprite CustomSprite8 = ModAPI.LoadSprite("CustomSprite8.png");
        public static Sprite CustomSprite10 = ModAPI.LoadSprite("CustomSprite10.png");
        public static Sprite CustomSprite11 = ModAPI.LoadSprite("CustomSprite11.png");
        public static Sprite CustomSprite13 = ModAPI.LoadSprite("CustomSprite13.png");
        public static Sprite CustomSprite14 = ModAPI.LoadSprite("CustomSprite14.png");
        public static Sprite CustomSprite15 = ModAPI.LoadSprite("CustomSprite15.png");
        public static Sprite CustomSprite16 = ModAPI.LoadSprite("CustomSprite16.png");
        public static Sprite CustomSprite17 = ModAPI.LoadSprite("CustomSprite17.png");
        public static Sprite CustomSprite18 = ModAPI.LoadSprite("CustomSprite18.png");
        public static Sprite CustomSprite19 = ModAPI.LoadSprite("CustomSprite19.png");
        public static Sprite CustomSprite20 = ModAPI.LoadSprite("CustomSprite20.png");
        public static Sprite CustomSprite21 = ModAPI.LoadSprite("CustomSprite21.png");
        public static Sprite CustomSprite22 = ModAPI.LoadSprite("CustomSprite22.png");
        public static Sprite CustomSprite23 = ModAPI.LoadSprite("CustomSprite23.png");
        public static Sprite CustomSprite24 = ModAPI.LoadSprite("CustomSprite24.png");
        public static Sprite CustomSprite26 = ModAPI.LoadSprite("CustomSprite26.png");
        public static Sprite CustomSprite27 = ModAPI.LoadSprite("CustomSprite27.png");
        public static Sprite CustomSprite28 = ModAPI.LoadSprite("CustomSprite28.png");
        public static Sprite CustomSprite29 = ModAPI.LoadSprite("CustomSprite29.png");
        public static Sprite CustomSprite30 = ModAPI.LoadSprite("CustomSprite30.png");
        public static Sprite CustomSprite31 = ModAPI.LoadSprite("CustomSprite31.png");
        public static Sprite CustomSprite33 = ModAPI.LoadSprite("CustomSprite33.png");
        public static Sprite CustomSprite35 = ModAPI.LoadSprite("CustomSprite35.png");
        public static Sprite CustomSprite37 = ModAPI.LoadSprite("CustomSprite37.png");
        public static Sprite CustomSprite39 = ModAPI.LoadSprite("CustomSprite39.png");
        public static Sprite CustomSprite40 = ModAPI.LoadSprite("CustomSprite40.png");
        public static Sprite CustomSprite41 = ModAPI.LoadSprite("CustomSprite41.png");
        public static Sprite CustomSprite42 = ModAPI.LoadSprite("CustomSprite42.png");
        public static Sprite CustomSprite43 = ModAPI.LoadSprite("CustomSprite43.png");
        public static Sprite Imageh9sgbtdcvkitedsi6g = ModAPI.LoadSprite("Imageh9sgbtdcvkitedsi6g.png");
        

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void OnLoad()
		{
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
			// 
			Map MapMod = ScriptableObject.CreateInstance<Map>();
			MapMod.name = MapName;
			MapMod.UniqueIdentity = Guid.NewGuid().ToString();
			MapMod.Description = "Map";
			MapMod.Thumbnail = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Preview = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
			MapModName = MapMod.name;
			MapRegistry.Register(MapMod);
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
				{
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
			var whitespace = Texture2D.whiteTexture;
			whitespace.Resize(16, 16);
			whitespace.Apply();
			if (IsTexture == true)
			{
				var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
														(int)spritey.textureRect.y,
														(int)spritey.textureRect.width,
														(int)spritey.textureRect.height);
				croppedTexture.SetPixels(pixels);
				croppedTexture.wrapMode = TextureWrapMode.Repeat;
				croppedTexture.filterMode = FilterMode.Point;
				croppedTexture.Apply();
				var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
				NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
				NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			else
			{
				NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				NewGameobject.GetComponent<SpriteRenderer>().color = color;
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
			NewGameobject.transform.parent = null;
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			switch (Type)
			{
				case "Water":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						break;
					}
				case "Acid":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						Water.name = "Acid";
						Water.AddComponent<AcidWater>();
						break;
					}
				case "Lava":
					{
						Map lavaMap = Resources.Load<Map>("Maps/Lava");
						GameObject LavaBefore = lavaMap.Prefab.transform.Find("Lava pool").gameObject;
						var Lava = Instantiate<GameObject>(LavaBefore, Vector3.zero, Quaternion.identity);
						Lava.transform.rotation = Rotation;
						Lava.transform.localScale = new Vector2(Size.x, -Size.y);
						Lava.transform.localPosition = Pos;
						break;
					}
			}
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap.name == MapModName)
			{
				Debug.Log("Setting up some stuff.");
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
		public static void InitilizeMap()
		{
			foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			foreach (var waterBlock in GameObject.FindObjectsOfType<LavaBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			
			CreateCustomGameObjects("Custom", new Vector2(35.10288f, 4.215508f), new Vector2(0.7000003f, 0.7500002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(34.30781f, -0.2608562f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(45.25209f, -0.2608562f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(56.19637f, -0.2756848f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(46.30796f, 2.372452f), new Vector2(3.379998f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(36.86057f, 4.316306f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(55.41415f, 4.18048f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(57.18828f, 4.176421f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(32.32765f, 4.216808f), new Vector2(-0.8999988f, 0.7500002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(48.30448f, 5.980364f), new Vector2(2.769998f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(59.91022f, 3.432663f), new Vector2(0.8300002f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(60.09431f, 3.642645f), new Vector2(-0.9599987f, 0.9400001f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(65.27991f, -0.5125253f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(73.19318f, -0.6797072f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(83.96246f, -0.846889f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(94.89893f, -0.8468887f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(59.8862f, 8.004204f), new Vector2(0.8400002f, 0.8100002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(52.43435f, 7.796871f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(49.03462f, 7.80062f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(43.41068f, 7.802225f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(37.7631f, 7.796367f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(35.15493f, 7.796366f), new Vector2(0.7000003f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(52.5085f, 3.540516f), new Vector2(1f, 0.97f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(39.65675f, 3.460343f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(47.97959f, 9.757229f), new Vector2(2.769998f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(59.83357f, 5.938098f), new Vector2(2.379999f, 1.27f), Quaternion.Euler(0f, 0f, -4.802387E-07f), CustomSprite13, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(59.89924f, 8.224796f), new Vector2(0.8300002f, 1.11f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(59.92654f, 11.04018f), new Vector2(0.8300002f, 1.18f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(44.33197f, 16.79977f), new Vector2(2.969998f, 2.169999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.98064f, 15.88098f), new Vector2(2.289999f, 3.149998f), Quaternion.Euler(0f, 0f, 0f), CustomSprite15, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(32.32244f, 7.844459f), new Vector2(-0.8999988f, 0.7900002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(32.33483f, 11.73211f), new Vector2(-0.8999988f, 0.8400002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(42.77448f, 19.18597f), new Vector2(1.879999f, 2.779998f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", false, -1);
                CreateCustomGameObjects("Custom", new Vector2(54.23241f, 16.28288f), new Vector2(1.39f, 1.659999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", false, -1);
                CreateCustomGameObjects("Custom", new Vector2(51.50264f, 17.81044f), new Vector2(1.699999f, 2.169999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14, "Back", false, -2);
                CreateCustomGameObjects("Custom", new Vector2(56.80459f, 11.83283f), new Vector2(1.15f, 1.24f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(50.5312f, 11.77628f), new Vector2(-1.159999f, 1.23f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(44.21646f, 11.78174f), new Vector2(-1.159999f, 1.23f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(37.86567f, 11.67119f), new Vector2(-1.159999f, 1.31f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(35.65288f, 11.64862f), new Vector2(1.15f, 1.29f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(55.2562f, 7.151966f), new Vector2(1.08f, 1.04f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.97156f, 7.186623f), new Vector2(1.03f, 1.04f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(39.65857f, 3.82598f), new Vector2(1f, 0.96f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(52.55676f, 3.834556f), new Vector2(-1.309998f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(60.90293f, 10.06808f), new Vector2(1.879999f, 1.22f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.12918f, 10.17409f), new Vector2(1.37f, 1.37f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(35.49429f, 4.260569f), new Vector2(0.7700002f, 0.7600002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(48.28267f, 3.438708f), new Vector2(1.729999f, 1.619999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21, "Front", false, 0);
                CreateSpawnable("Wooden Chair", new Vector2(46.2639f, 3.277529f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), true, false);
                CreateSpawnable("Wooden Chair", new Vector2(50.35084f, 3.319084f), new Vector2(-1.009999f, 1f), Quaternion.Euler(0f, 0f, 0f), true, false);
                CreateCustomGameObjects("Custom", new Vector2(48.30329f, 3.779315f), new Vector2(1.27f, 1.689999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(37.49957f, 10.73419f), new Vector2(1.51f, 1.539999f), Quaternion.Euler(0f, 0f, 90.30002f), CustomSprite22, "Back", true, -3);
                CreateCustomGameObjects("Custom", new Vector2(38.56166f, 3.678296f), new Vector2(1.51f, 1.539999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22, "Back", true, -3);
                CreateCustomGameObjects("Custom", new Vector2(44.88845f, 3.22049f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite23, "Back", true, -2);
                CreateCustomGameObjects("Custom", new Vector2(43.12204f, 3.22552f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite24, "Back", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(58.72824f, 6.325457f), new Vector2(1.01f, 0.99f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Front", true, -5);
                CreateCustomGameObjects("Custom", new Vector2(38.3933f, 6.088062f), new Vector2(1.46f, 1.05f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Front", true, -5);
                CreateCustomGameObjects("Custom", new Vector2(55.7368f, 7.945917f), new Vector2(1.02f, 0.7400002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite26, "Back", true, -10000);
                CreateCustomGameObjects("Custom", new Vector2(51.56079f, 11.12081f), new Vector2(1.51f, 1.539999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22, "Back", true, -3);
                CreateCustomGameObjects("Custom", new Vector2(53.49195f, 7.355636f), new Vector2(1.51f, 1.539999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22, "Back", true, -3);
                CreateCustomGameObjects("Custom", new Vector2(41.17463f, 3.121987f), new Vector2(1.48f, 0.7700002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22, "Back", true, -3);
                CreateCustomGameObjects("Custom", new Vector2(41.36701f, 3.949429f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite27, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(55.2985f, 7.483842f), new Vector2(-1.309998f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.27861f, 10.27765f), new Vector2(2.529999f, 1.939999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(44.91175f, 10.31764f), new Vector2(2.369999f, 2.109999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.64592f, 10.8073f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite29, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(44.74014f, 10.90642f), new Vector2(1f, 1.35f), Quaternion.Euler(0f, 0f, 0f), CustomSprite29, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(44.54531f, 10.86199f), new Vector2(1f, 0.9300001f), Quaternion.Euler(0f, 0f, 0f), CustomSprite29, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(45.47501f, 10.8449f), new Vector2(1f, 1.27f), Quaternion.Euler(0f, 0f, 0f), CustomSprite29, "Front", false, 0);
                CreateLightSources("Light", new Vector2(45.16796f, 11.09546f), new Vector2(2.889998f, 2.670017f), Quaternion.Euler(0f, 0f, 0f), new Color32(100, 93, 0, 0), 1f);
                CreateCustomGameObjects("Custom", new Vector2(45.12296f, 10.93718f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite30, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(47.31028f, 4.051174f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite30, "Front", false, 0);
                CreateSpawnable("Glass Pane", new Vector2(59.90242f, 8.416555f), new Vector2(1f, 1.19f), Quaternion.Euler(0f, 0f, 0f), true, true);
                CreateSpawnable("Glass Pane", new Vector2(59.94689f, 11.93199f), new Vector2(1f, 1.769999f), Quaternion.Euler(0f, 0f, 0f), true, true);
                CreateCustomGameObjects("Custom", new Vector2(23.38386f, -0.271462f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(12.41748f, -0.2820673f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(1.790492f, -0.3669134f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(-9.133459f, -0.3350966f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(43.82104f, 6.848017f), new Vector2(2.019999f, 2.039999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite31, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(42.44322f, 6.554059f), new Vector2(1f, 1.579999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite33, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(42.15903f, 7.214275f), new Vector2(1.24f, 1.09f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(42.66444f, 7.338243f), new Vector2(1.539999f, 1.739999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(57.05086f, 6.51288f), new Vector2(2.139999f, 2.099999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(57.38985f, 7.375996f), new Vector2(2.599998f, 2.229999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(57.89273f, 6.52631f), new Vector2(1.699999f, 2.059999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(53.42316f, 11.14714f), new Vector2(2.079999f, 2.109999f), Quaternion.Euler(0f, 0f, 130.9f), CustomSprite35, "Back", true, -2);
                CreateCustomGameObjects("Custom", new Vector2(40.16862f, 6.841558f), new Vector2(2.079999f, 2.109999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite35, "Back", true, -2);
                CreateCustomGameObjects("Custom", new Vector2(36.27567f, 3.171554f), new Vector2(2.079999f, 2.109999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite35, "Back", true, -2);
                CreateCustomGameObjects("Custom", new Vector2(53.41818f, 3.211004f), new Vector2(2.019999f, 2.039999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite31, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(39.29098f, 10.74433f), new Vector2(2.019999f, 2.039999f), Quaternion.Euler(0f, 0f, 60.20002f), CustomSprite31, "Back", true, -5);
                CreateCustomGameObjects("Custom", new Vector2(61.96796f, -2.334626f), new Vector2(1.739999f, 1.16f), Quaternion.Euler(0f, 0f, 90.30002f), CustomSprite4, "Back", true, -100);
                CreateCustomGameObjects("Custom", new Vector2(33.04769f, 7.899778f), new Vector2(-0.8399988f, 0.8300002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite20, "Back", true, -5);
                CreateCustomGameObjects("Custom", new Vector2(48.45449f, 4.930541f), new Vector2(1.859999f, 1.819999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite37, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(49.13276f, 4.137132f), new Vector2(1.709999f, 1.539999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite28, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(57.14494f, 3.376046f), new Vector2(1.39f, 1.39f), Quaternion.Euler(0f, 0f, 0f), CustomSprite39, "Back", true, -3);
                CreateCustomGameObjects("Custom", new Vector2(54.82547f, 3.841019f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Back", true, -2);
                CreateCustomGameObjects("Custom", new Vector2(1148.348f, 1.355042f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1144.486f, 1.354582f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1141.048f, 1.354582f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1137.862f, 1.348572f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1132.332f, 1.360593f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1127.379f, 1.348571f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1122.594f, 1.348571f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(1117.707f, 1.34256f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite40, "Front", false, 0);
                CreateGameObjects("Other", new Vector2(1134.276f, 3.142208f), new Vector2(1542.31f, 942.2499f), Quaternion.Euler(0f, 0f, 0f), "Back", true, -10000);
                CreateGameObjects("Other", new Vector2(1137.452f, 502.2518f), new Vector2(1842f, 34342f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(609.5158f, 474.0128f), new Vector2(35142.98f, 36542f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(49.43473f, 6.862352f), new Vector2(2.269999f, 2.269999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite41, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(49.89862f, 7.216204f), new Vector2(1.01f, 0.99f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Front", true, -5);
                CreateCustomGameObjects("Custom", new Vector2(49.43349f, 7.063223f), new Vector2(-1.259998f, 2.419999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite19, "Front", true, -5);
                CreateCustomGameObjects("Custom", new Vector2(45.97476f, 7.523602f), new Vector2(1.579999f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17, "Front", true, 0);
                CreateCustomGameObjects("Custom", new Vector2(102.7028f, -1.095624f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", false, 5);
                CreateCustomGameObjects("Custom", new Vector2(49.8308f, 4.197472f), new Vector2(1f, 1.09f), Quaternion.Euler(0f, 0f, 0f), CustomSprite42, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(44.37597f, 4.197472f), new Vector2(1f, 1.09f), Quaternion.Euler(0f, 0f, 0f), CustomSprite42, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(42.4294f, 4.213968f), new Vector2(1f, 1.09f), Quaternion.Euler(0f, 0f, 0f), CustomSprite42, "Back", true, -10);
                CreateCustomGameObjects("Custom", new Vector2(12.1771f, 17.75864f), new Vector2(2.559999f, 2.749998f), Quaternion.Euler(0f, 0f, 0f), CustomSprite43, "Back", true, -1000);
                CreateCustomGameObjects("Custom", new Vector2(24.96638f, 12.31434f), new Vector2(1.599999f, 1.889999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite43, "Back", true, -1000);
                CreateCustomGameObjects("Custom", new Vector2(1.546207f, 10.54253f), new Vector2(1.46f, 1.759999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite43, "Back", true, -1000);
                CreateCustomGameObjects("Custom", new Vector2(77.79227f, 9.684318f), new Vector2(1.45f, 1.52f), Quaternion.Euler(0f, 0f, 0f), CustomSprite43, "Back", true, -1000);
                CreateCustomGameObjects("Custom", new Vector2(87.22038f, 11.104f), new Vector2(1.549999f, 1.739999f), Quaternion.Euler(0f, 0f, 0f), CustomSprite43, "Back", true, -1000);
                CreateCustomGameObjects("Custom", new Vector2(97.41296f, 5.388875f), new Vector2(0.8600001f, 0.7900002f), Quaternion.Euler(0f, 0f, 0f), CustomSprite43, "Back", true, -1000);
                CreateBackground("Background", new Color32(255, 255, 255, 255), Mod.Imageh9sgbtdcvkitedsi6g, true);
                
		}
	}
	public class AcidWater : MonoBehaviour
	{
		private void Start()
		{
			SpriteRenderer spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
			spriteRenderer.material.shader = Shader.Find("Sprites/Default");
			spriteRenderer.material.color = new Color(0, 1f, 0.1509f, 0.1819f);
			spriteRenderer.color = new Color(0, 1, 0, 1);
		}
		private void OnTriggerEnter2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<LimbBehaviour>() != null)
			{
				collider2D.gameObject.AddComponent<AcidEffect>();
			}
		}
		private void OnTriggerExit2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<AcidEffect>() != null)
			{
				UnityEngine.Object.Destroy(collider2D.gameObject.GetComponent<AcidEffect>());
			}
		}

	}
	public class AcidEffect : MonoBehaviour
	{
		LimbBehaviour limbBehaviour;
		private void Start()
		{
			limbBehaviour = gameObject.GetComponent<LimbBehaviour>();
		}
		private void Update()
		{
			limbBehaviour.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 0.05f * Time.deltaTime);
		}
	}
	public class MapModManager : MonoBehaviour
	{
		private void Start()
		{
			Mod.InitilizeMap();
		}
	}

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
			{
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
	{
		public string Particles1;
		public float Speed1;
		public void Awake()
		{
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
	}
}

